/***********************************************************************************
ClipFigura.java - Exemplo de tcnica de clipping

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Exemplo de tcnica de clipping

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

// pacotes de desenho do AWT
import java.awt.geom.Ellipse2D;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Event;

public class ClipFigura extends Frame {

  public static void main(String args[]){

    // Define dimenses da janela de desenho como frao
    // da dimenso do monitor
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    int w = screenSize.width/5;
    int h = screenSize.height/5;

    // Chama o construtor
    ClipFigura frame = new ClipFigura();
    frame.setSize(w, h);
    frame.setVisible(true);
    frame.setTitle("ClipFigura");
  }

  // construtor do objeto
  public ClipFigura(){

  }

  // sobrecarrega o mtodo grfico paint()
  public void paint(Graphics g) {
    Graphics2D g2 = (Graphics2D)g;

    Rectangle rt = new Rectangle(20, 20, 180, 100);
    Ellipse2D clipEllipse = new Ellipse2D.Float(120, 70, 100, 100);

    g2.clip(clipEllipse);
    g2.setPaint(Color.blue); 
    g2.fill(rt);
  }

  // Encerra a aplicao clicando no "close"
  public boolean handleEvent(Event event) {
    if (event.id == Event.WINDOW_DESTROY)
       System.exit(0);
       return false;
  }
}
