/***********************************************************************************
DesenhaShape.java - Cdigo para mostrar diferentes formas grficas.

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Cdigo para mostrar diferentes formas grficas.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

// pacotes de desenho do AWT
import java.awt.Font;
import java.awt.Frame;
import java.awt.Event;
import java.awt.Color;
import java.awt.Toolkit;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.geom.Arc2D;
import java.awt.Graphics2D;
import java.awt.BasicStroke;
import java.awt.geom.Ellipse2D;

public class DesenhaShape extends Frame {

  public static void main(String args[]){

    // Define dimenses da janela de desenho como frao
    // da dimenso do monitor
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    int w = screenSize.width/4;
    int h = screenSize.height/4;

    // Chama o construtor
    DesenhaShape frame = new DesenhaShape();
    frame.setSize(w, h);
    frame.setVisible(true);
    frame.setTitle("DesenhaShape");
  }

  // construtor do objeto
  public DesenhaShape(){

  }

  // sobrecarrega o metodo grfico paint()
  public void paint(Graphics g){
    Graphics2D g2 = (Graphics2D)g;
    
    // Parte 1. Escreve ttulo

    // Passo 1: define atributos cor e fonte do contexto grfico
    g2.setPaint(Color.black); 
    g2.setFont(new Font("Century Gothic", Font.PLAIN, 15)); 
    
    // Passo 2: Seleciona objeto grfico: String
    String texto = "Desenhando Shapes com Java 2D";

    // Passo 3: chama o mtodo de desenho
    g2.drawString(texto, 10, 15);

    // Parte 2. Desenha Shapes
    drawArc(g2);
    drawRectangle(g2);
    drawElipse(g2);
  }

  void drawArc(Graphics2D g2) {
   
    // Passo 1: define atributos cor do contexto grfico
    g2.setPaint(Color.blue); 

    // Passo 2: Seleciona objeto grfico: Arc2D
    Arc2D arco = new Arc2D.Float(10f, 25f, 50f, 40f, 45f, 105f, Arc2D.PIE);

    // Passo 3: chama o mtodo de desenho
    g2.fill(arco);
  }

  void drawRectangle(Graphics2D g2) {

    // define e preenche retngulo

    // Passo 1: define atributo cor do contexto grfico
    g2.setPaint(Color.red); 

    // Passo 2: Seleciona objeto grfico: Rectangle
    Rectangle rect = new Rectangle(50, 70, 50, 50);

    // Passo 3: chama o mtodo de desenho: preenchido
    g2.fill(rect);

    // desenha contorno

    // Passo 1: define atributos cor e largura de linha
    //           do contexto grfico
    g2.setPaint(Color.black); 
    g2.setStroke(new BasicStroke(5));

    // Passo 3: chama o mtodo de desenho: contorno
    //          o objeto Rectangle j estava selecionado
    g2.draw(rect);
  }

  void drawElipse(Graphics2D g2) {
   
    // Passo 1: define atributos cor e largura de linha
    //           do contexto grfico
    g2.setPaint(Color.green); 
    g2.setStroke(new BasicStroke(3));

    // Passo 2: Seleciona objeto grfico: Ellipse2D.
    //          Perceber as duas maneiras de definir float no Java:
    //             1. com Arc2D usamos o sufixo "f": 10f.
    //             2. aqui usamos o metodo tradicional: 80.0
    Ellipse2D elipse = new Ellipse2D.Double(110.0, 130.0, 70.0, 50.0);

    // Passo 3: chama o mtodo de desenho: contorno
    g2.draw(elipse);
  }

  // Encerra a aplicao clicando no "close"
  public boolean handleEvent(Event event) {
    if (event.id == Event.WINDOW_DESTROY)
       System.exit(0);
       return false;
  }
}
