/***********************************************************************************
DesenhaTexto.java - Cdigo para mostrar um texto digitado no teclado

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Cdigo para mostrar um texto digitado no teclado, por exemplo:
      java -cp . DesenhaTexto "Jos Miranda"

    Se o texto tiver espao branco, deve vir acompanhado de aspas.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

// pacotes de desenho do AWT
import java.awt.Font;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Event;
import java.awt.Toolkit;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.RenderingHints;

public class DesenhaTexto extends Frame {
  static String texto = null;

  public static void main(String args[]){
    // Certifica a passagem do parmetro
    if (args.length != 1) {
       String msga = "Uso: java -cp . DesenhaTexto <texto>";
       System.out.println(msga);
       System.exit(0);
    }

    texto = args[0];

    // Define dimenses da janela de desenho como uma frao
    // da dimenso do monitor
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    int w = screenSize.width/4;
    int h = screenSize.height/5;

    // Chama o construtor
    DesenhaTexto frame = new DesenhaTexto();
    frame.setSize(w, h);
    frame.setVisible(true);
    frame.setTitle("DesenhaTexto");
  }

  // construtor do objeto
  public DesenhaTexto(){

  }

  // sobrecarrega o mtodo grfico paint()
  public void paint(Graphics g){
    Graphics2D g2 = (Graphics2D)g;
    
    //
    // Passo 1: define atributos cor e fonte do contexto grfico
    // 
    g2.setPaint(Color.black); 
    g2.setFont(new Font("Century Gothic", Font.PLAIN, 60)); 
    
    // Tcnica especial para tornar textos (e grficos) mais suavizados
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
                       RenderingHints.VALUE_ANTIALIAS_ON);     

    //
    // Passo 2: Seleciona objeto grfico para desenhar.
    //          Neste caso, um String "texto" digitado no teclado

    //
    // Passo 3: chama o mtodo de desenho
    //
    g2.drawString(texto, 40, 80);
  }

  // Encerra a aplicao clicando no "close"
  public boolean handleEvent(Event event) {
    if (event.id == Event.WINDOW_DESTROY)
       System.exit(0);
       return false;
  }
}
