/***********************************************************************************
FillGradiente.java - Cdigo para preencher um retngulo com um gradiente circular

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Cdigo para preencher um retngulo com um gradiente circular

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

// pacotes de desenho do AWT
import java.awt.Frame;
import java.awt.Event;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GradientPaint;
import java.awt.geom.Rectangle2D;

public class FillGradiente extends Frame {

  public static void main(String args[]){

    // chama o construtor
    FillGradiente frame = new FillGradiente();
    frame.setSize(150, 150);
    frame.setVisible(true);
    frame.setTitle("FillGradiente");
  }

  // construtor do objeto
  public FillGradiente() {
  }

  // sobrecarrega o mtodo grfico paint()
  public void paint(Graphics g){
    Graphics2D g2 = (Graphics2D)g;

    //    
    // Passo 1: define atributo cor, neste caso, gradiente, do contexto grfico:
    //    
    GradientPaint gp = new GradientPaint(10, 10, // Ponto da cor inicial do gradiente
                           Color.red,            // Cor inicial
                           85, 75,               // Ponto da cor final do gradiente
                           Color.green,          // Cor final
                           true);                // Gradiente cclico. Se false,
                                                 // gradiente ser acclico
    g2.setPaint(gp); 
    
    //
    // Passo 2: Seleciona objeto grfico para desenhar.
    //          Neste caso, um retngulo
    Rectangle2D retangulo = new Rectangle2D.Double(10, 10, 100, 80);

    //
    // Passo 3: chama o mtodo de desenho
    //
    g2.fill(retangulo);
  }

  // Encerra a aplicao clicando no "close"
  public boolean handleEvent(Event event) {
    if (event.id == Event.WINDOW_DESTROY)
       System.exit(0);
       return false;
  }
}
