/***********************************************************************************
Image_IO.java - Terceiro mtodo de carga de imagem (modo imediato)

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Terceiro mtodo de carga de imagem (modo imediato): ImageIO com BufferedImage

Parmetros de entrada:

  1. nome do arquivo imagem, escolhido na janela interativa.

Sada:

  Painel com imagem.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

// pacote genrico
import java.io.File;

// pacotes do AWT
import java.awt.Frame;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

// pacote Swing
import javax.swing.JFileChooser;

// leitura em modo imediato - para J2SE 1.4+
import javax.imageio.ImageIO;

public class Image_IO extends Frame {
  // Define um objeto BufferedImage para encapsular a imagem
  private BufferedImage imagem;

  public static void main(String args[]) {

		File file = null;
		int result;

    // Comandos Swing para abrir janela com arquivos.
		JFileChooser fileChooser = new JFileChooser(".");
		fileChooser.setDialogTitle("Abre imagem");
		result = fileChooser.showOpenDialog(null);
		if (result == JFileChooser.APPROVE_OPTION) {
			file = fileChooser.getSelectedFile();
		} else {
      System.out.println("Escolher imagem.");
			System.exit(0);
		}

    // Chama o construtor
    Frame f = new Image_IO(file);
  }

  public Image_IO(File file) {

    try {
      imagem = ImageIO.read(file);
    } catch(Exception e) {
      System.out.println("Imagem '" + file + "' nao existe.");
      System.exit(0);
    }

    // Atribui nome ao frame
    setTitle("Image_IO: " + file.getName());

    // Define dimenso do Frame
    setSize(imagem.getWidth(), imagem.getHeight());
    setVisible(true);
  }

	// sobrecarrega o metodo grfico paint()
  // para desenhar a imagem
  public void paint(Graphics g) {
     Graphics2D g2 = (Graphics2D)g;

     // Translada origem da imagem e desenha
     g2.translate(this.getInsets().left,this.getInsets().top);
     g2.drawImage(imagem, 0, 0, this);
   }

   // Encerra a aplicao clicando no "close"
   public boolean handleEvent(Event event) {
     if (event.id == Event.WINDOW_DESTROY)
        System.exit(0);
        return false;
   }
}
