/***********************************************************************************
ModoImediato.java - Cdigo para testar o mtodo modo imediato

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Cdigo para testar o mtodo modo imediato.
    Leitura em modo imediato - para J2SE 1.4+.

Parmetros de entrada:

  1. nome do arquivo imagem.

Sada:

  Valores da largura e altura da imagem.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

// pacotes genricos
import java.io.File;

// pacote do AWT
import java.awt.image.BufferedImage;

// leitura em modo imediato - para J2SE 1.4+
import javax.imageio.ImageIO;

public class ModoImediato {

   // Certifica a passagem da imagem como parmetro
   public static void main(String args[]) {
     if (args.length != 1) {
        System.out.println("Uso: java -cp . ModoImediato <arquivo_imagem>");
        System.exit(0);
     }

     // Chama o construtor
     ModoImediato mm = new ModoImediato();
     mm.load(args[0]);
   }

   public void load(String filename) {
     BufferedImage imagem = null;

     // Carrega imagem
     File file = new File(filename);
     try {
       imagem = ImageIO.read(file);
     } catch(Exception e) {
       System.out.println("Imagem '" + filename + "' nao existe.");
       System.exit(0);
     }

     // Recupera largura e altura da imagem e imprime valores
     int w = imagem.getWidth();
     int h = imagem.getHeight();
     System.out.println("largura = " + w + ", altura = " + h);

   }

}

