/***********************************************************************************
Binariza.java - Binariza imagem usando valor limiar.

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Binariza imagem usando valor limiar. Objeto do pacote 'classes'.

Parmetros de entrada:

  1. BufferedImage 'src'.
  2. int 'teto' - valor de limiarizao para binarizar imagem.

Sada:

  Imagem binarizada.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

package classes;

// pacotes do AWT
import java.awt.image.WritableRaster;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;

public class Binariza {

   // Binariza imagem sem lookup table
   public BufferedImage binarizaOp(BufferedImage src, int teto) {

     int binMax = 255, binMin = 0, w, h, tipo;

     w = src.getWidth();
     h = src.getHeight();
     tipo = BufferedImage.TYPE_BYTE_GRAY;
     BufferedImage out = new BufferedImage(w, h, tipo);
     WritableRaster outWR = out.getRaster();
     Raster srcR = src.getRaster();

     for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++) {
            if (srcR.getSample(j, i, 0) <= teto)
               outWR.setSample(j, i, 0, binMin);
            else
               outWR.setSample(j, i, 0, binMax);
        }
     return out;
   }     
  
}
