/***********************************************************************************
Erode.java - Implementa operao morfolgica de eroso.

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Erode uma imagem. Objeto do pacote 'classes'.

Parmetros de entrada:

  1. BufferedImage 'src'.

Sada:

  Imagem erodida.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

package classes;

// pacotes do AWT
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.Color;

public class Erode {
	
  public BufferedImage erodeOp(BufferedImage src) {
  
		int w, h, tipo;

    // Define elemento estruturante
    int mFilter[][] = {{0,1,0},{1,1,1},{0,1,0}};

	  h = src.getHeight();
	  w = src.getWidth();
	  tipo = BufferedImage.TYPE_BYTE_GRAY;
	  BufferedImage dst = new BufferedImage(w, h, tipo);

    // Aplica filtro de eroso na imagem original
    System.out.println("Calculando filtro de erosao...");
    dst = erodeOp(src, mFilter);

    // Retorna imagem com filtro de abertura
    return dst;
  }

  BufferedImage erodeOp(BufferedImage in, int afiltro[][]) {

		int min_red, min_green, min_blue, srcPixel, red, green, blue,	w, h;
    Color c;

	  BufferedImage bfi = null;
    ColorModel cm = in.getColorModel();
	  
    w = in.getWidth();
    h = in.getHeight();
    bfi = new BufferedImage(cm, cm.createCompatibleWritableRaster(w, h),
                    cm.isAlphaPremultiplied(), null);

    for (int i = 2; i < h-2; i++) {
    	 for (int j = 2; j < w-2; j++) {
    	    min_red = min_green = min_blue = 255;
    	    for (int k = -1; k <= 1; k++) {
     	       for (int l = -1; l <= 1; l++) {
                if (afiltro[l+1][k+1] == 1) {
        					srcPixel = in.getRGB(j+l, i+k);
									c   = new Color(srcPixel);
									red   = c.getRed();
									green = c.getGreen();
									blue  = c.getBlue();
									min_red = Math.min(red, min_red);
									min_green = Math.min(red, min_green);
									min_blue = Math.min(red, min_blue);
								}	// if
						 }	// for l
       	     bfi.setRGB(j, i, new Color(min_red, min_green, min_blue).getRGB());
					}	// for k
			 }	// for j
		}	// for i

    return bfi;
	}

}
