/***********************************************************************************
FiltroMediana.java - Implementa um filtro de mediana para passa-baixa.

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Filtra uma imagem. Objeto do pacote 'classes'.

Parmetros de entrada:

  1. BufferedImage 'src'.

Sada:

  Imagem filtrada.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

package classes;

// pacote genrico
import java.util.Arrays;

// pacotes do AWT
import java.awt.image.Raster;
import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;

public class FiltroMediana {

   public BufferedImage medianaOp(BufferedImage src) {

	 int w, h, tipo, mediana[], tmp, i; 

	 h = src.getHeight();
	 w = src.getWidth();
	 mediana = new int[9];
	 tipo = BufferedImage.TYPE_BYTE_GRAY;
   BufferedImage outImagem = new BufferedImage(w, h, tipo);
   WritableRaster wR = outImagem.getRaster();
   Raster srcR = src.getRaster();

	 for (int lin = 1; lin < h-2; lin++)
		for (int col = 1; col < w-2; col++) {
			// Le os 9 pixels para a matriz mediana
			tmp = 0;
			for (int y1 = -1; y1 < 2; y1++)
				for (int x1 = -1; x1 < 2; x1++) {
          mediana[tmp] = srcR.getSample(col+x1, lin+y1, 0);
					tmp++;
				}
				// Ordena os valores em ordem crescente
				/*
				for (int j = 1; j < 9; j++) {
					tmp = mediana[j];
					i = j - 1;
					while (i >= 0 && mediana[i] > tmp) {
						mediana[i+1] = mediana[i];
						i--;
					}
					mediana[i+1] = tmp;
				}
				*/
			// Melhor usar o sort do Java
			Arrays.sort(mediana);
      wR.setSample(col, lin, 0, mediana[4]);
		}
    return outImagem;
   }

}
