/***********************************************************************************
FiltroImg.java - Filtros para tipos de imagens a serem lidas.

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

    Filtro para tipo de extenso de arquivo de imagens. Usado na opo 
    "Abrir" do GUIMain. Objeto do pacote 'classes'.

Parmetros de entrada:

  1. Janela com tipos de arquivos de imagens que podem ser lidas pelo Java.

Sada:

  Imagem selecionada.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

package classes;

// pacote genrico
import java.io.File;

// pacote Swing para interface grfica
import javax.swing.filechooser.FileFilter;

public class FiltrosImg extends FileFilter {

	// Aceita arquivos de imagens nos formatos gif, jpg, tiff, ou png
  public boolean accept(File f) {
		if (f.isDirectory()) {
			return true;
		}

		String extension = TipoRaster.getExtension(f);
		if (extension != null) {
			if (extension.equals(TipoRaster.tiff) ||
				extension.equals(TipoRaster.tif) ||
				extension.equals(TipoRaster.gif) ||
				extension.equals(TipoRaster.jpeg) ||
				extension.equals(TipoRaster.jpg) ||
				extension.equals(TipoRaster.png)) {
				return true;
			} else {
				return false;
			}
		}

		return false;
	}

	// Descrio do filtro
	public String getDescription() {
		return "Imagens";
	}
}