/***********************************************************************************
GUIInternalFrame.java - classe usada pelo programa GUIMain, 
                        mtodo createFrame().

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

  Classe usada pelo programa GUIMain, metodo createFrame(). 
  Objeto do pacote 'classes'.

Parmetros de entrada:

  No se aplica.

Sada:

  Cria um GUIInternalFrame para mostrar imagem.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

package classes;

// pacotes Swing para interface grfica
import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

// pacote do AWT
import java.awt.image.BufferedImage;

public class GUIInternalFrame extends JInternalFrame {

	static int openFrameCount = 0;
  static final int xOffset = 30, yOffset = 30;
  public BufferedImage img1 = null;

  public GUIInternalFrame() {
		super("Imagem #" + (++openFrameCount), 
           true,					// resizable
           true,					// closable
           true,					// maximizable
           true);					// iconifiable

    // Cria GUI e a coloca na janela
    setSize(300,300);

    // Localizao da janela
    setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
  }
    
  public void setImage(BufferedImage img) {
		img1 = img;
    JLabel imgL1 = new JLabel(new ImageIcon(img1));
    getContentPane().add(new JScrollPane(imgL1)); 
  }
}