/***********************************************************************************
TipoRaster.java - Define tipos de arquivos de imagens vlidos.

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

  Classe para definir tipos de arquivos de imagens vlidos. Objeto do pacote 
  'classes'.

Parmetros de entrada:

  1. Seleo do tipo de imagem.

Sada:

  Tipo de imagem.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

package classes;

// pacote genrico
import java.io.File;

// pacote Swing
import javax.swing.ImageIcon;

public class TipoRaster {
	public final static String jpeg = "jpeg";
  public final static String jpg = "jpg";
  public final static String gif = "gif";
  public final static String tiff = "tiff";
  public final static String tif = "tif";
  public final static String png = "png";

  // Pega a extenso do arquivo
  public static String getExtension(File f) {
		String ext = null;
    String s = f.getName();
    int i = s.lastIndexOf('.');

    if (i > 0 &&  i < s.length() - 1) {
			ext = s.substring(i+1).toLowerCase();
    }
		return ext;
  }

  // Retorna um ImageIcon, ou null se o caminho for invlido
  protected static ImageIcon createImageIcon(String path) {
		java.net.URL imgURL = TipoRaster.class.getResource(path);
    if (imgURL != null) {
			return new ImageIcon(imgURL);
    } else {
			System.err.println("Nao encontrou arquivo: " + path);
      return null;
    }
  }
}