/***********************************************************************************
ZIntensifica.java - Intensificao de imagem com mtodo de Zadeh.

Direitos Autorais Reservados (c) 2006 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

**********************************************************************************

Parte integrante do software 'Processamento de Imagens Digitais'

Descrio:

  Intensificao de imagem com mtodo de Zadeh.. Objeto do pacote 'classes'.

Parmetros de entrada:

  1. BufferedImage 'src'.

Sada:

  Imagem intensificada.

Desenvolvido por:

  Joo Camargo Neto.

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

***********************************************************************************/

package classes;

// pacotes do AWT
import java.awt.image.Raster;
import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;

public class ZIntensifica {
	int largura, altura;
	
	public double[][] fuzifica (BufferedImage src) {
    int linha, rp, coluna;
		double mu[][] = new double[altura][largura];
		Raster srcR = src.getRaster();
		int lin = 0;
		for (linha = 0; linha < altura; linha++) {
	    for (coluna = 0;coluna < largura; coluna++) {
	      rp  =  srcR.getSample(coluna, linha, 0);
	      mu[linha][coluna] = (double)rp/255;
      }
		}
		return mu;
	}

	public BufferedImage deFuzifica (double[][] mu) {
		int linha, rp, coluna, tipo;
		long val;

    tipo = BufferedImage.TYPE_BYTE_GRAY;
		BufferedImage destImage =	new BufferedImage(largura, altura, tipo);
		WritableRaster destWR = destImage.getRaster();

		for (linha = 0; linha < altura; linha++) {
      for (coluna = 0;coluna < largura; coluna++) {
        val = Math.round(mu[linha][coluna]*255);
	      destWR.setSample(coluna, linha, 0, val);
	    }
		}
		return destImage;
	}	
		
	public double[][] intensifica(double[][] mu, int nun) {
		int linha, coluna;
		double val, bp = 0.5;

		for (int n = 1; n <= nun; n++){
			for (linha = 0; linha < altura; linha++) {
        for (coluna = 0;coluna < largura; coluna++) {
		      val = mu[linha][coluna];
		      if (val > bp)
		        mu[linha][coluna] = 1 - 2*((1-val)*(1-val));
		      else
		        mu[linha][coluna] =2*(val*val) ;
		    }
			}
		}
		return mu;
	}
	
	public BufferedImage zadeh (BufferedImage img, int nun) {
		double[][] buf1, buf2;

		largura = img.getWidth();
		altura = img.getHeight();
		BufferedImage outImg = null;

		buf1 = fuzifica (img);
		buf2 = intensifica(buf1,nun);
		outImg = deFuzifica(buf2);
		return outImg;
	}
}
